#Copyright (C) 2010 Splunk Inc. All Rights Reserved. This work contains trade
#secrets and confidential material of Splunk Inc., and its use or disclosure in
#whole or in part without the express written permission of Splunk Inc. is prohibited.

# Created to call the fileclassifier from an external python package
# so that the the picked python objects have the same module name as
# when the fileclassifier is called from C++.  Python writse the name
# of the module as __main__, rather than splunk.fileclassier, making
# the xml impossible to parse back out unless you call is from an
# external python file.

import sys
import splunk.fileclassifier



def usage():
    print 'Usage \n'
    print 'To learn: ' 
    print '\tsplunk train <file> <type> attributesdictionary\n'
    print '\te.g., splunk train foo.log weblogic "{\'break-before-date\':\'True\', \'aggregate\':\'True\'}"\n'
    print 'To test: ' 
    print '\tsplunk train <file>\n'
    print 'To reset training: '
    print '\tsplunk train  reset\n'
    print 'To set to default setup: '
    print '\tsplunk train default\n'


if __name__ == '__main__':

    if len(sys.argv) == 4:
        logfilename = sys.argv[1]
        filetype = sys.argv[2]
        attrString = sys.argv[3]
        attributes = None
        exec("attributes = " + attrString)
        knownClassifier   = splunk.fileclassifier.getClassifier(splunk.fileclassifier.getTyperDataFilename(True),  splunk.fileclassifier.getTyperPropertiesFileName(True))
        typeAttrs = knownClassifier.getProperties().get(filetype)
        defaultAttrs = knownClassifier.getDefaultSettings()

        # for each attribute/value in current type's attributes
        ## add it if it doesn't already have a value
        if typeAttrs != None:
            for attr,val in typeAttrs.items():
                if attr not in attributes :
                    attributes[attr] = val
        # try adding default if not added
        for attr,val in defaultAttrs.items():
            if attr not in attributes :
                attributes[attr] = val
                
        print 'Adding type:', filetype, 'with attributes:', attributes
        attrDict = splunk.fileclassifier.TypeSettings(attributes)
        knownClassifier.learnFileType( logfilename, filetype, attrDict)

    elif len(sys.argv) == 2:
        command = sys.argv[1]
        if command == 'reset' or command == 'default':
            knownClassifier   = splunk.fileclassifier.getClassifier(splunk.fileclassifier.getTyperDataFilename(True),  splunk.fileclassifier.getTyperPropertiesFileName(True))
            unknownClassifier = splunk.fileclassifier.getClassifier(splunk.fileclassifier.getTyperDataFilename(False), splunk.fileclassifier.getTyperPropertiesFileName(False))
            splunk.fileclassifier.resetClassifier(knownClassifier)
            splunk.fileclassifier.resetClassifier(unknownClassifier)
            if command == 'default':
                splunk.fileclassifier.setupFileTyper();
        else:
            returnDict = splunk.fileclassifier.TypeSettings(None)
            logfilename = sys.argv[1]
            splunk.fileclassifier.getFileType(returnDict, logfilename)
            print "\nVALUES:\t", str(returnDict.items())
    else:
        usage()


