# Copyright (C) 2005-2010 Splunk Inc.  All Rights Reserved.  Version 4.0
#!/usr/bin/env python


# nmap -p 80,8000,8080,8088 tiny.splunk.com
# nmap -sP -T insane -oG foo mcdavid/24
# 
# grepable =  -oG
# OS = -O
# 
# sudo nmap  tiny
# sudo nmap -O tiny/24
# sudo nmap -sX -O tiny
# nmap -v -O tiny
#

import os, time, stat, re, sys, subprocess
import crawl
import logging as logger

NETWORKCMD = "nmap %s/%s"

# !! need to ensure no quotes, spaces, ;, etc.  no funny business in command.
def exeCommand(command, input = ""):
     logger.info("network crawl = %s" % command)
     p = subprocess.Popen(command.split(' '),stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
     output = p.communicate(input + "\n")[0]
     return output
 
class NetworkCrawler(crawl.Crawler):

    def __init__(self, mgr, args):
         name = args.get("name", "network")
         crawl.Crawler.__init__(self, name, mgr, args)
         self.network_info = {}
         # GET SETTINGS
         logger.info("network crawl settings =  '%s'" % self.settings)
         self.index  = self.getSetting("index", "main")
         self.host   = self.getSetting("host", "localhost")         
         self.subnet = self.getSetting("subnet", "64")         
     
    def execute(self):
        # CRAWL
        events = self._doCrawl()
        
        # CREATE RESULT ACTIONS
        actions = []
        for raw in events:
             event = {}
             event['_raw'] = raw
             event['crawler_type'] = self.name
             event['_time'] = time.time()
             event['index'] = self.index
             actions.append(crawl.AddHostAction(event))
        return actions

    def _doCrawl(self):
         events = []
         event = ""
         lines = exeCommand( NETWORKCMD % (self.host, self.subnet) )
         for line in lines.split('\n'):
              if len(line) == 0:
                   if len(event) > 0:
                        events.append(event)
                        event = ""
              else:
                   event += line + '\n'
         # don't add last event.  it's just a summary
         # if len(event) > 0:
         #     events.append(event)
         return events
