# Copyright (C) 2005-2010 Splunk Inc.  All Rights Reserved.  Version 4.0
import sys,splunk.Intersplunk
import re
import urllib
import xml.sax.saxutils as sax

XML_KV_RE = re.compile("<(.*?)(?:\s[^>]*)?>([^<]*)</\\1>")


try:
    results,dummyresults,settings = splunk.Intersplunk.getOrganizedResults()
    
    for r in results:
        if "_raw" in r:
            raw = r["_raw"]
            rawOut = sax.unescape( raw )
            while( rawOut != raw ):
                raw = rawOut
                rawOut = sax.unescape( raw )                
            r["_raw"] = rawOut

            for kvpair in XML_KV_RE.findall(rawOut):
                r[kvpair[0]] = kvpair[1]

except:
    import traceback
    stack =  traceback.format_exc()
    results = splunk.Intersplunk.generateErrorResults("Error : Traceback: " + str(stack))

splunk.Intersplunk.outputResults( results )
