# Copyright (C) 2005-2010 Splunk Inc.  All Rights Reserved.  Version 4.0 
#
# This file contains possible attribute/value pairs for creating user entry fields for your custom application.
# Configure available fields for user entry via app.conf.

# There is no default app.conf.  To set custom configurations, place an app.conf in 
# $SPLUNK_HOME/etc/system/local/. For examples, see app.conf.example.  
# You must restart Splunk to enable configurations.
# 
# To learn more about configuration files (including precedence) please see the documentation 
# located at http://www.splunk.com/base/Documentation/latest/Admin/Aboutconfigurationfiles

#
# Set install settings for this app
#

# launcher settings
# -------------------
# to view your app in the initial launcher app place an image for the icon and screenshot in the appserver/static dir of your app
# eg. appIcon_<appname>.png, screenshot_<appname>.png
# the spec for these images are as follows:
# app icons need to be 36x36 pixels, in PNG format
# screenshots need to be a minimum of 490 x 275 but can be larger, as they will be automatically cropped. they should also be PNG format and should not have any browser chrome in it
# the images can be in any of the following formats: png, jpg, jpeg, gif
# To set other properties such as author etc, create a stanza called [launcher] in your app.conf and provide the following info
# author
# description
# version

[install]

state = disabled | enabled
* Set whether app is disabled or enabled.
* If an app is disabled, its configs are ignored.
* By default, apps are enabled.

state_change_requires_restart = true | false
* Set whether removing/enabling/disabling app requires a restart of Splunk.
* Defaults to true.

#
# Set UI-specific settings for this app
#

[ui]

is_visible = true | false
* Indicates if this app should be visible/navigable as a UI app
* Apps require at least 1 view to be available from the UI

is_manageable = true | false
* Indicates if Splunk Manager should be used to manage this app
* Defaults to true
    
label = <string>
* Defines the friendly label for the app
    

#
# Set custom configuration file settings for this app
#

[config:$STRING]
* Name your stanza.
* Preface with config:.
* Set $STRING to any arbitrary identifier.
	
targetconf = <$CONFIG_FILE>
* Target configuration file for changes.
* There can be only one.
* Any configuration file that is included in the application.
* For example indexes, for indexes.conf.
	
targetstanza = <$STANZA_NAME>
* Stanza name from application.
	
targetkey = <$ATTRIBUTE>
* Attribute to set.
	
targetkeydefault = <$VALUE>
* Default setting for attribute.
* Can be empty for no default.
	
conflabel = <$LABEL>
* Short description of configuration to display in Splunk Web.
