# Copyright (C) 2005-2010 Splunk Inc.  All Rights Reserved.  Version 4.0 
#
# This file contains possible attribute/value pairs for search language macros

# To learn more about configuration files (including precedence) please see the documentation 
# located at http://www.splunk.com/base/Documentation/latest/Admin/Aboutconfigurationfiles

[$STANZA_NAME]
	* Each stanza represents a search macro that can be referenced in any search
	* The stanza name is the name of the macro if the macro takes no arguments.  Otherwise,
	  the stanza name is the macro name append with "(<numargs>)", where <numargs> is the number of arguments that this macro takes.
	* macros may be overloaded so there can be [foobar] and [foobar(1)] and [foobar(2)] etc
	* macros can be used in the search language by enclosing the macro name and any argument list within tick marks, e.g. `foobar(arg1,arg2)` or `foobar`
	* no macro expansion are attempted inside of quoted values, e.g. "foo`bar`baz"

args = <string>
        * A comma delimited string of argument names.
	* Argument names may only contain the characters alphanumerics and underscore '_' and dash '-'
	* If the stanza name indicates this macro takes no arguments, this key will be ignored
	* It is an error if this list contains any repeated elements

definition = <string>
	* The string that the macro will expand to, with the arguments filled in. (exception if iseval = true, see below)
	* Arguments to be filled in must be wrapped by dollar signs $ e.g. "the last part of this string will be replaced by the value of argument foo $foo$"   
	* If a $ is not followed by the name of an argument (specified in the args list) followed by another $, it will be ignored and interpreted as a literal $
	* the $...$ pattern will be replace globally in the string, even inside of quotes
	
validation = <string>
	* A validation string that is an 'eval' expression.  This expression must statically either evaluate to a boolean or a string.
	* This validation is for verifying that the argument value used to invoke this macro are acceptable
	* If the validation expression is a boolean expression, validation succeeds when it returns true.  If it returns false or is null, validation fails, and the error message defined by 'errormsg' is returned.
	* If the validation expression is not a boolean expression, it is expected to return a string or null.  For this case, if it returns null, validation is considered a success.  Otherwise, the string returned is rendered as the error string.

errormsg = <string>
	* The error message to be displayed if validation is a boolean expression and it does not evaluate to true.

iseval = <true/false>
        * If true, 'definition' is expected to be an eval expression that returns a string that represents the expansion of this macro.
        * Defaults to false
