# Copyright (C) 2005-2010 Splunk Inc.  All Rights Reserved.  Version 4.0 
#
# This file contains possible attribute/value pairs for configuring WMI access from Splunk.  
#
# There is a wmi.conf in $SPLUNK_HOME\etc\system\default\.  To set custom configurations, 
# place a wmi.conf in $SPLUNK_HOME\etc\system\local\. For examples, see 
# wmi.conf.example.  You must restart Splunk to enable configurations.
# 
# To learn more about configuration files (including precedence) please see the documentation 
# located at http://www.splunk.com/base/Documentation/latest/Admin/Aboutconfigurationfiles

#########################################################################################
#----GLOBAL SETTINGS-----
#########################################################################################

[settings]
	* The settings stanza specifies various runtime parameters.
	* The entire stanza and every parameter within it is optional. 
	* If the stanza is missing, Splunk assumes system defaults.

initial_backoff = <integer>
	* How long to wait (in seconds) before retrying the connection to the WMI provider after the first connection error.
	* If connection errors continue, the wait time doubles until it reaches max_backoff.
	* Defaults to 5.
	
max_backoff = <integer>
	* Maximum time (in seconds) to attempt reconnect.
	* Defaults to 20.
	
max_retries_at_max_backoff = <integer>
	* Try to reconnect this many times once max_backoff is reached.
	* If reconnection fails after max_retries, give up forever (until restart).
	* Defaults to 2.
	
result_queue_size = <integer>
	* Puts results from WMI provider(s) into a queue, then send to output.
	* Defaults to 1000.
	
checkpoint_sync_interval = <integer>
	* Minimum wait time (in seconds) for state data (event log checkpoint) to be written to disk.
	* Defaults to 2.
	
heartbeat_interval = <integer>
	* Heartbeat interval (in milliseconds) to test connection to WMI providers. 
	* Defaults to 500.

#########################################################################################
#----INPUT-SPECIFIC SETTINGS-----
#########################################################################################

[WMI:$NAME]
	* There are two types of WMI stanzas:
 		* Event log: for pulling event logs. You must set the event_log_file attribute.
 		* WQL: for issuing raw WQL requests. You must set the WQL attribute.

server = <comma-separated list>
	* A comma-separated list of servers from which to get data. 
	* Defaults to local machine.

interval = <integer>
	* How often to poll for new data. 
	* Not optional.
	* No default.

disabled = <1/0>
	* 1 to disable, 0 to enable.
	* No default.
 
* Event log-specific attributes:
 
event_log_file = <Application, System, etc>
	* Use this instead of WQL to specify sources.
	* Specify a comma-separated list of log files to poll.
	* No default.

* WQL-specific attributes:

wql = <string>
	* Use this if you're not using event_log_file.
	* Specify wql to extract data from WMI provider.
	* For example, select * from Win32_PerfFormattedData_PerfProc_Process where Name = "splunkd".
	
namespace = <string>
	* Location of WMI providers.
	* The namespace where the WMI provider resides. 
	* Direct WQL queries.
	* Defaults to root\.