## {| cellpadding="5" cellspacing="0" border="1"
##  ! Column1 name
##  ! Column2 name
##  ! Columnx name
##  |-
##  | Row1 Column1
##  | Row1 Column2
##  | Row1 Columnx
##  |-
##  | Row2 Column1
##  | Row2 Column2
##  | Row2 Columnx
##  |}

import sys,os
import splunk.mining.conf as conf
import splunk.mining.dcutils as dcutils
from xml.sax import saxutils

OUTPUT_PATH = os.path.join('wiki', 'literals.wiki')

filechoices = {
    'madonna':"../../../../cfg/bundles/default/literals.conf.in",
    '32': "../../../../../3.2/cfg/bundles/default/literals.conf.in",
    '32strings':"../../../../../3.2/cfg/bundles/default/strings.conf"
}


def printHuman(stanzas):
    for name, values in stanzas.items():
        if name.isupper():
            print "%s" % name
            for attr,val in values.items():
                print "\t%s %s" % (attr, val)

def writeWiki(stanzas, all=False):
    out = """
{| cellpadding="5" cellspacing="0" border="1"
! MODULE
! STRING_NAME
! TEXT
"""
    keys = stanzas.keys()
    keys.sort()
    for name in keys:
        values = stanzas[name]
        if name.isupper() or all:
            out += """|-
| %s
| 
| """ % name
            
            for attr,val in values.items():
                attr = attr.split("__")[0]
                val  = saxutils.escape(val)
                val  = val.replace("|", "&#124;")
                out += """|-
| 
| %s
| %s """ % (attr, val)
    out += """
|}"""

    dcutils.writeText(OUTPUT_PATH, out)
    

def printUsage():
    print "Usage: python %s %s" % (sys.argv[0], filechoices.keys())
    
if __name__ == '__main__':
    argc = len(sys.argv)
    argv = sys.argv
    if argc == 2:
        filename = argv[1]
        if not filename in filechoices:
            printUsage()
        else:
            writeWiki(conf.ConfParser.parse(filechoices[filename], True), filename=='32literals')
    else:
        printUsage()
