import os, sys, dcutils
import FieldLearning

import logging
logging.basicConfig(level=logging.DEBUG)
logger = logging
_debug = None

def aggregateEvents(events):
    newevents = []
    current = ""
    for event in events:
        event = event.strip()
        if len(event) > 0:
            current += event + "\n"
        else:
            newevents.append(current)
            current = ""
    return newevents

def testFile(filename, examples, counterexamples, goals, isMultiline=False):
    passed = True
    events = dcutils.loadLines(filename)
    if isMultiline:
        events = aggregateEvents(events)
        
    regexes, extracted = FieldLearning.learn(events, examples, counterexamples)
    for goal in goals:
        if goal not in extracted or 0 not in extracted[goal]:
            print "FAIL: DIDN'T LEARN:", goal
            passed = False
            break
    else:
        print "GREAT SUCCESS!"
    if len(regexes) == 0:
        print "No regexes"
        passed = False
    else:
        print "\tRegexes: %s" % regexes[0]
        print "\tExtracted: %s" % [e for e in extracted if 0 in extracted[e]]
        print "\tExamples: %s" % examples
        print "\tCounterExamples: %s" % counterexamples

    return passed


testFile('ifxtest/test1.txt', ['mcdavid', 'mcdavid-2'], ['purgeable'], ['mcdavid', 'mcdavid-2'])
testFile('ifxtest/test1.txt', ['kernel', 'configd'], [], ['mDNSResponder'])
testFile('ifxtest/test1.txt', ['9918'], [], ['189'])
testFile('ifxtest/test1.txt', ['10:40:15'], [], ['10:20:36'])

testFile('ifxtest/test2.txt', ['96', '99', '98'], [], ['100'], True)
testFile('ifxtest/test3.txt', ['PST'], ['Feb'], ['PDT'])

testFile('ifxtest/test4.txt', ['MetricLogger'], [], ['MetricLogger'])
testFile('ifxtest/test4.txt', ['com.cme.falcon.common.metric.DatabaseMetric'], [], ['com.cme.falcon.common.metric.OrderEntryOutboundMetric'])
testFile('ifxtest/test4.txt', ['2.0'], [], ['1.0', '0.0'])
testFile('ifxtest/test4.txt', ['120012'], [], ['120012'])
testFile('ifxtest/test4.txt', ['1237589103687'], [], ['1237589223699'])

testFile('ifxtest/test5.txt', ['mod_compress.c'], [], ['server.c'], True)    

testFile('ifxtest/test6.txt', ['var'], [], ['var'], True)    

testFile('ifxtest/test7.txt', ['216.129.119.11'], [], ['159.83.252.230'])    

testFile('ifxtest/test8.txt', ['127.0.0.1:631','fe80::1%lo0:631127'], [], ['/private/var/run/cupsd'])

testFile('ifxtest/test9.txt', ['5B1754C470B','0A7A44C4707'], [], ['5B1754C470B'])

testFile('ifxtest/testinternational.txt', ['POSITION'], [], ['POSITION'])
testFile('ifxtest/testinternational.txt', ['Euro'], [], ['Chinese'])
testFile('ifxtest/testinternational.txt', ['Ek get'], [], ['Ek get'])

