# Copyright (C) 2005-2010 Splunk Inc.  All Rights Reserved.  Version 4.0
# -*- coding: utf-8 -*-

import os, random,sys,re
import splunk.searchhelp.utils as su
import splunk.mining.conf as conf

ignored_processors = ['crawl', 'set', 'gentimes', 'appendcols', 'map', 'localize', 'autoregress', 'rex', 'rare', 'top', 'kmeans', 'erex']

i18nText = [
"Unë mund të ha qelq dhe nuk më gjen gjë.",
"أنا قادر على أكل الزجاج و هذا لا يؤلمني.",
"Կրնամ ապակի ուտել և ինծի անհանգիստ չըներ։",
" 我能吞下玻璃而不傷身體",
"Jeg kan spise glas, det gør ikke ondt på mig.",
"€.",
"Je peux manger du verre, ça ne me fait pas de mal.",
"მინას ვჭამ და არა მტკივა.",
"Μπορώ να φάω σπασμένα γυαλιά χωρίς να πάθω τίποτα.",
"Hiki iaʻu ke ʻai i ke aniani; ʻaʻole nō lā au e ʻeha.",
"אני יכול לאכול זכוכית וזה לא מזיק לי.",
"मैं काँच खा सकता हूँ, मुझे उस से कोई पीडा नहीं होती.",
"Ég  get etið gler án þess að meiða mig.",
"ang=Korean sample=나는 유리를 먹을 수 있어요. 그래도 아프지 않아요",
"ang=Macedonian sample=Можам да јадам стакло, а не ме штета.",
"ang=Old Norse sample=Ek get etið gler án þess að verða sár.",
"Mogę jeść szkło, i mi nie szkodzi.",
"Pot să mănânc sticlă și ea nu mă rănește.",
"Mogu jesti staklo a da mi ne škodi.",
"நான் கண்ணாடி சாப்பிடுவேன், அதனால் எனக்கு ஒரு கேடும் வராது.",
"ฉันกินกระจกได้ แต่มันไม่ทำให้ฉันเจ็บ",
"Tôi có thể ăn thủy tinh mà không hại gì.",
"lang=Albanian sample=Unë mund të ha qelq dhe nuk më gjen gjë.",
"Unë mund të ha qelq dhe nuk më gjen gjë.",
"Կրնամ ապակի ուտել և ինծի անհանգիստ չըներ։",
"lang=Armenian sample=Կրնամ ապակի ուտել և ինծի անհանգիստ չըներ։",
"Կրնամ ապակի ուտել և ինծի անհանգիստ չըներ։",
" 我能吞下玻璃而不傷身體",
"Jeg kan spise glas, det gør ikke ondt på mig.",
"Je peux manger du verre, ça ne me fait pas de mal.",
"lang=French sample=Je peux manger du verre, ça ne me fait pas de mal.",
"Je peux manger du verre, ça ne me fait pas de mal.",
"მინას ვჭამ და არა მტკივა.",
"Μπορώ να φάω σπασμένα γυαλιά χωρίς να πάθω τίποτα.",
"Hiki iaʻu ke ʻai i ke aniani; ʻaʻole nō lā au e ʻeha.",
"אני יכול לאכול זכוכית וזה לא מזיק לי.",
"मैं काँच खा सकता हूँ और मुझे उससे कोई चोट नहीं पहुंचती.",
"Ég  get etið gler án þess að meiða mig.",
"lang=Korean sample=나는 유리를 먹을 수 있어요. 그래도 아프지 않아요",
"나는 유리를 먹을 수 있어요. 그래도 아프지 않아요",
"Можам да јадам стакло, а не ме штета.",
"Би шил идэй чадна, надад хортой биш",
"Ek get etið gler án þess að verða sár.",
"Mogę jeść szkło, i mi nie szkodzi.",
"Pot să mănânc sticlă și ea nu mă rănește.",
"Mogu jesti staklo a da mi ne škodi.",
"Μπορώ να φάω σπασμένα γυαλιά χωρίς να πάθω τίποτα."
]

def getCommands(onlypublic=True):
    commands = {}
    examples = []
    stanzas = conf.ConfParser.parse(os.environ['SPLUNK_HOME'] + "/etc/system/default/searchbnf.conf", True)
    stanzanames = stanzas.keys()
    for stanzaname in stanzanames:
        val = stanzas[stanzaname]
        if stanzaname.endswith("-command") and (not onlypublic or su.isPublic(val)):
            name = stanzaname[0:-8]
	    if name in ignored_processors:
		    continue
	    stanza       = stanzas[stanzaname]
            for attr in stanza.keys():
                if attr.startswith("example"):
			ex = stanza[attr].strip()
			if ex.startswith("..."):
				ex = ex[3:]
			ex = ex.strip()
			if ex.startswith("|"):
				ex = ex[1:].strip()
			else:
				ex = "search " + ex
			if not name in commands:
				commands[name] = []
			commands[name].append(ex)
			examples.append(ex)
    return commands, examples

commands, examples = getCommands()
processors = commands.keys()

keywords = [
"*", "meta::all", "OR", "AND", "NOT", "100000000000000d", "-100000000d", "../../..", "../", "/", "%s", "%ld", "%s", "%s", "%ld", "%s", "%s", "%ld", "%s", "%s", "%ld", "%s", "%s", "%ld", "%s", "_actions", "_align_", "_all_", "_black_", "_c", "_cd", "_chop_", "_count", "_ct_count", "_cvcount", "_d", "_data_type", "_dummytype", "_duration", "_eg", "_index", "_k", "_k__", "_key", "_keyset", "_keyval", "_kv", "_meta", "_mkv_child", "_mkv_id", "_msg_type", "_none_", "_noseg", "_query", "_raw", "_regex_", "_related", "_scale", "_segs", "_server", "_sp_", "_sp_bc", "_sp_bv", "_sp_ct_k__", "_sp_dc_k__", "_sp_tc", "_sp_tv", "_summary", "_time", "_tokenize_", "_type", "_v", "_val", "_white_", "_xml", "AND", "AS", "DD", "HH", "LIKE", "MM", "NOT", "OR", "OUTPUT", "SS", "XOR", "YY", "abs", "abstract", "accum", "action", "add", "addinfo", "addtime", "addtotals", "af", "agg", "aliases", "allnum", "allowempty", "allrequired", "annotate", "anomalies", "anomalousvalue", "append", "appendcols", "as", "associate", "attr", "attribute", "attrn", "audit", "auto", "autoregress", "avg", "bcc", "bins", "blacklist", "blacklistthreshold", "bottom", "bucket", "bucketdir", "by", "c", "case", "cb", "cc", "cfield", "chart", "chunk", "chunksize", "cidrmatch", "cityblock", "classfield", "clean", "closest", "cluster", "cmd", "coalesce", "cocur", "col", "collapse", "collect", "concat", "connected", "consecutive", "cont", "context", "contingency", "convert", "copyattrs", "copyresults", "correlate", "cos", "cosine", "count", "counterexamples", "countfield", "crawl", "createinapp", "createrss", "cs", "csv", "ctime", "current", "d", "day", "days", "daysago", "dbinspect", "dc", "debug", "dedup", "default", "delete", "deleterestrict", "delim", "delims", "delta", "desc", "descr", "dest", "dictionary", "diff", "dispatch", "distinct", "ds", "dt", "dur", "earlier", "ema", "end", "enddaysago", "endhoursago", "endminutesago", "endmonthsago", "endswith", "endtime", "erex", "eval", "eventcount", "events", "eventstats", "eventtype", "eventtypetag", "exact", "examples", "exp", "extract", "false", "field", "fieldname", "fields", "file", "fillnull", "filter", "first", "floor", "folderize", "forceheader", "form", "format", "from", "fromfield", "gentimes", "global", "graceful", "h", "head", "header", "high", "highest", "highlight", "hilite", "host", "hosts", "hosttag", "hour", "hours", "hoursago", "hr", "hrs", "html", "id", "idxprobe", "if", "ifnull", "improv", "in", "increment", "index", "indexdelete", "inline", "input", "inputcsv", "inputlookup", "internalinputcsv", "intersect", "ip", "iplocation", "iqr", "isbool", "isint", "isnotnull", "isnull", "isnum", "isstr", "join", "k", "keepempty", "keepevents", "keepevicted", "keeplast", "keepsingle", "keys", "kmeans", "kvform", "l", "label", "labelfield", "labelonly", "last", "len", "like", "limit", "link", "list", "ln", "loadjob", "local", "localize", "log", "logchange", "lookup", "low", "lower", "lowest", "ltrim", "m", "makecontinuous", "makemv", "map", "marker", "match", "math", "max", "maxchars", "maxcols", "maxcount", "maxevents", "maxfolders", "maxinputs", "maxiters", "maxlen", "maxlines", "maxopenevents", "maxopentxn", "maxout", "maxpause", "maxresolution", "maxresults", "maxrows", "maxsample", "maxsearches", "maxspan", "maxterms", "maxtime", "maxtrainers", "maxvalues", "md", "mean", "median", "memk", "metadata", "metainclude", "min", "mincolcover", "minfolders", "minrowcover", "mins", "minute", "minutes", "minutesago", "mktime", "mode", "mon", "month", "months", "monthsago", "ms", "mstime", "multikv", "multitable", "mv", "mvcombine", "mvcount", "mvexpand", "mvfilter", "mvindex", "mvlist", "name", "newseriesfilter", "ngramset", "noheader", "nokv", "nomv", "none", "norm", "normalize", "nosubstitution", "not", "notin", "now", "null", "nullif", "nullstr", "num", "optimize", "or", "otherstr", "outfield", "outlier", "outputatom", "outputcsv", "outputlookup", "outputraw", "outputrawr", "outputtext", "overlap", "override", "overwrite", "p", "param", "path", "pathfield", "pattern", "perc", "perl", "pi", "position", "pow", "prefix", "priority", "private", "process", "pthresh", "public", "python", "random", "range", "rangemap", "rare", "raw", "rawstats", "readlevel", "regex", "relevancy", "reload", "remove", "rename", "replace", "reps", "resample", "rescan", "reverse", "rex", "rm", "rmcomma", "rmorig", "rmunit", "roll", "round", "row", "rtrim", "s", "sample", "savedsearch", "savedsplunk", "script", "scrub", "search", "searchkeys", "searchmatch", "searchtimespandays", "searchtimespanhours", "searchtimespanminutes", "searchtimespanmonths", "sec", "second", "seconds", "secs", "sed", "seedcount", "segment", "select", "selfjoin", "sendemail", "sep", "server", "set", "setfields", "setsv", "showargs", "showcount", "showlabel", "showperc", "sichart", "sid", "singlefile", "sirare", "sistats", "sitimechart", "sitop", "size", "sizefield", "sleep", "sma", "sort", "sortby", "source", "sources", "sourcetype", "sourcetypes", "span", "spawn", "spool", "sq", "sqeuclidean", "sqrt", "start", "startdaysago", "starthoursago", "startminutesago", "startmonthsago", "startswith", "starttime", "starttimeu", "stats", "stdev", "stdevp", "str", "strcat", "streamedcsv", "streamstats", "substr", "sum", "summary", "supcnt", "supfreq", "surrounding", "sync", "t", "tag", "tagcreate", "tagdelete", "tags", "tagset", "tail", "termlist", "terms", "termset", "testmode", "text", "tf", "threshold", "time", "timeafter", "timebefore", "timechart", "timeconfig", "timeformat", "timeout", "to", "tokenizer", "tol", "top", "tostring", "totalfield", "totalstr", "transaction", "transform", "trendline", "trim", "true", "tsidx", "ttl", "type", "typeahead", "typelearner", "typeof", "typer", "union", "uniq", "untable", "upper", "urldecode", "us", "uselower", "usenull", "useother", "usetime", "usetotal", "usexml", "validate", "value", "values", "var", "varp", "where", "window", "with", "wma", "xmlkv", "xmlunescape", "xpath", "xyseries"
]



def randElement(L):
	return L[random.randint(0, len(L)-1)]

def randomargument():
	arg = ""
	# random characters
	r = random.random()
	if r > 0.95:
		return "true"
	elif r > 0.9:
		return "false"
        elif r > 0.85:
            return "%ld"*10
        elif r > 0.8:
            return randElement(i18nText)
        elif r > 0.75:
            return '"' + randElement(i18nText) + '"'
	elif r > 0.3:
		l = random.randint(1,8) #30
		for i in range(0, l):
                        #ch = chr(random.randint(1,255))
			ch = chr(random.randint(32,126))
			#if ch == "'" or ch == '`' or ch == '"' or ch == '[' or ch == ']' or ch == '$' or ch == '!' or ch == '\n' or ch == '\r' or ch == '|':
			if ch == "'" or ch == '|':
				ch = '_'
			elif ch == '\\':
				ch = "\\\\"
			arg += ch
		arg = '\"' + arg + '\"'
	elif r > 0.2:
		arg = str(random.randint(1,9999))
	elif r > 0.1:
		arg = randElement(keywords) + "=" + randomargument()
	else:
		arg = randElement(keywords)
        if random.random() > .8:
               arg = '"' + arg + '"'
	return arg

def randomizeNumbers(s):
       for n in re.findall("\d+", s):
              r = random.random()
              if r > .9:
                     val = "0"
              elif r > .8:
                     val = "%s-%s" % (str(random.randint(-101,1001)), str(random.randint(-101,1001)))
              elif r > .7:
                     val = "1000000000000000000000000"
              elif r > .6:
                  val = chr(random.randint(0,30))
              elif r > .3:
                     val = random.randint(-101,1001) 
              else:
                     val  = randomargument()
              s = s.replace(n, str(val))
              if len(s) > 300: # handle weird case of replacing 0 with 100000000 forever
                     break
       return s;

MAX_ARGS = 5

def randomOperator():
	# if random.random() < .95:
	r = random.random()
	if r > 0.95:
		operator = "search [" + generateRandomQuery() + "] "
	if r > .3:
		operator = randElement(examples) + " " 
		argcount = random.randint(0, 1)
		for j in range(0, argcount):
			operator += randomargument() + " "
	else:
		operator = randElement(processors) + " "
		argcount = random.randint(0, MAX_ARGS)
		for j in range(0, argcount):
			operator += randomargument() + " "

	operator = randomizeNumbers(operator)
	return operator

MAX_PIPE = 4

def generateRandomQuery():
	query = ""
	filename = "results.csv"
        #filename = str(random.randint(1, 13)) + ".csv"
	if random.random() > 0.5:
		query = "inputcsv " + filename + " max=%s" % random.randint(1,10000)
	elif random.random() > 0.1:
		query = "search * | head 100 " 
	barcount = random.randint(1,MAX_PIPE)
	for i in range(0, barcount):
		if len(query) > 0:
			query += " | "
		operator = randomOperator()
		query += operator
        #if random.random() > 0.5:
	#	query += " | outputxml "
	#query += " | search xxxxyxxxxxx" # prevent any large output

	if random.random() < 0.1:
            for i in range(0,10):            
		query = query.replace(str(i), chr(random.randint(30,140)))
            query = query.replace('*', '"' + randElement(i18nText) + '"')
	return query

def init():
    os.system('searchtest "file /Users/davidcarasso/DATA/logs/ALLLOGS| outputcsv results.csv"')    


def test():

    #os.system("searchtest \"|search * | outputcsv results.csv\"")
    #os.system('searchtest "gentimes start=1/1/1998|rename starttime as _time, starthuman as _raw | outputcsv results.csv"')
    os.system('searchtest "file /Users/davidcarasso/DATA/logs/ALLLOGS| outputcsv results.csv"')
    while True:
	    f = open("queries.txt", "w")
	    for i in range(1,1000):
		    query = generateRandomQuery()
		    #print "                 QUERY... " + query
		    f.write(query + "\n")
	    f.close()
	    ret = os.system("searchtest file queries.txt")
	    if ret != 0:
		    print "FAILED!!!!!!!!!!!!!"
		    exit(1)

if __name__ == '__main__':
    test()

