Splunk.Module.ConvertToIntention = $.klass(Splunk.Module, {
    
    initialize: function($super, container) {
        $super(container);
        this._intentionReplace = /\$target\$/;
        this._lastSetting = null;
    },
    
    searchAndReplaceIntention: function(intention, value) {
        for (var key in intention) {
           if (typeof intention[key] == 'object') {
               this.searchAndReplaceIntention(intention[key], value);
           }
           if (typeof intention[key] == 'string' && intention[key].match(this._intentionReplace)) {
               intention[key] = intention[key].replace(this._intentionReplace, Splunk.util.escapeSearchTerm(value));
           }
        }
        return intention;
    },

    getModifiedContext: function() {
        var context = this.getBaseContext();
        var setting = this.getSetting(this.getParam('settingToConvert'));
        if (!setting) return context;
        var intention = this.searchAndReplaceIntention($.extend(true, {}, this.getParam('intention')), setting);
        context.addIntention(intention);   
        return context;
    }
});
