Splunk.Module.SearchLinkLister = $.klass(Splunk.Module.AbstractSearchLister, {

    initialize: function($super, container) {
        $super(container);
        this._lastClicked = null;
    },

    getListValue: function() {
        var val = this._lastClicked;
        this._lastClicked = null;
        return val;
    },

    onUserAction: function($super, event) {
        var val = $(event.target).attr('rel');
        if (val != null) this._lastClicked = val;
        event.preventDefault();
        // we use the simonSays trick to make the framework's pushes NOT go through. 
        // but the user initiated pushes will always go through.
        this.pushSettingsToChildren();
        this.pushContextToChildren(null, true);
        //$super();
    },

    renderResults: function(html) {
        $('ul', this.container).empty();
        $('ul', this.container).append(html);
        $('div.error', this.container).prependTo(this.container);
        $('ul li a', this.container).bind('click', this.onUserAction.bind(this));
    },
    
    pushContextToChildren: function($super, explicitContext, simonSays) {
        var context = explicitContext || this.getModifiedContext();
        if (context.isResurrected() || simonSays) {
            $super(explicitContext);
        }
    }
    
    

});
