
Splunk.Module.AccountBar = $.klass(Splunk.Module, {

    initialize: function($super, container) {
        $super(container);
        
        var appList = this.getParam('appList') || [{'label': _('(No apps available)'), 'uri': '', 'id': ''}];
        
        if (appList.length == 0) {
            this.logger.error('Unable to construct app list; no apps found');
        }
        
        // add link to create a new app
        appList.push({
            'label': _('Create new app...'), 
            'uri': Splunk.util.make_url('manager', Splunk.util.getCurrentApp(), 'apps', 'local', '_new') + '?action=edit'
        });
        
        if ( $('#applicationsMenuActivator', this.container).length ) { 
            var appsMenu = new Splunk.MenuBuilder({
                containerDiv: this.container,
                menuDict: appList,
                activator: $('#applicationsMenuActivator', this.container),
                menuClasses: 'splMenu-secondary'
            });
        }
        
        $('.job_manager_opener', container).click(function() {
            Splunk.window.openJobManager();
            return false;
        });
        
        $('.splIcon-close', container).click(function() {
            window.close();
            return false;
        });
        
        var cancelJobsOnLogoClick = Splunk.util.normalizeBoolean(this._params.cancelJobsOnLogoClick);
        if(cancelJobsOnLogoClick) {
            $('.appLogo', container).click(function(event) {
                // if theres an href then we defer location change until the cancellation is complete.
                var target_uri = $(this).attr("href");
                // only get the jobs that can be autocancelled (we dont actually care if they're running or not)
                var jobs = Splunk.Globals.Jobber.listJobs(function(job){
                    return (job.canBeAutoCancelled());
                });
                if (jobs.length > 0) {
                    jobs.cancel(function() {
                        if (target_uri) {
                            document.location = target_uri;
                            return true;
                        }
                    });
                    if (target_uri) {
                        event.preventDefault();
                        return false;
                    }
                }
            });
            
            
        }
    }
   
});

