
//put Module in the namespace if it isnt already there.
Splunk.namespace("Module");

// Simple module to pull a single value out of a result set and display it
Splunk.Module.ShowSource = $.klass(Splunk.Module.DispatchingModule, {
    initialize: function($super, container) {
        $super(container);
        
        this.resultsContainer = $('.sourceText', container);
        
        this.logger = Splunk.Logger.getLogger("ShowSource.js");        

	this.onResize();
	$(window).resize(this.onResize.bind(this));
    },

    onResize: function() {
	var sourceText = $(".sourceText", this.container);
	var foo = $(window).height() - sourceText.offset().top;
	sourceText.height(foo);
    },
    onSettingsChange: function(evt) {
        this.getResults();
    },
    onLoadStatusChange: function(statusInt) {
	if (statusInt == Splunk.util.moduleLoadStates.LOADED)
	    this.getResults();
    },
    onResultsRendered: function() {
	var selectedRow  = $(".SourceLineHL", this.container);

	if (selectedRow) {
	    var sourceText   = $(".sourceText", this.container);
	    var sourceOffset = sourceText.offset().top;
	    var windowHeight = $(window).height();
	    var newScrollTop = selectedRow.offset().top - sourceOffset;
	
	    newScrollTop -= ((windowHeight - sourceOffset)/2);
	    
	    sourceText.scrollTop(Math.round(newScrollTop));
	}
    },
    getResultParams: function($super) {
        var params = $super();
        var baseContext = this.getBaseContext();
        var sid         = baseContext.job.getSearchId();
        var qsDict = Splunk.util.queryStringToProp(document.location.search);

        if (!sid) 
            this.logger.error(this.moduleType, "Assertion Failed. getResultParams was called, but searchId is missing from my job.")

        params.sid = sid;
	if (qsDict.hasOwnProperty("offset")) params.offset = qsDict["offset"];
	if (qsDict.hasOwnProperty("latest_time")) params.latest_time = qsDict["latest_time"];

	if (this.getSetting("count")) params.count = this.getSetting("count");

        return params;
    }    
});
