Splunk.Module.ViewstateAdapter = $.klass(Splunk.Module, {
    
    // define the sets of viewstate <-> settingsMap mapping to auto-import
    // from a viewstate set
    // the format is:
    //      {<module_name>: {<module_param_name>: <settings_map_key>}}
    //
    // NOTE: each module can have more than one param_name
    viewstateKeys: {
        'chart': {
            'AxisScaleFormatter':   {'default': 'charting.secondaryAxis.scale'},
            //'ChartTitleFormatter':  {'default': 'chartTitle'},
            'ChartTypeFormatter':   {'default': 'charting.chart'},
            'LegendFormatter':      {'default': 'charting.legend.placement'},
            'LineMarkerFormatter':  {'default': 'charting.chart.showMarkers'},
            'NullValueFormatter':   {'default': 'charting.chart.nullValueMode'},
            'StackModeFormatter':   {'default': 'charting.chart.stackMode'},
            'XAxisTitleFormatter':  {'default': 'charting.primaryAxisTitle.text'},
            'YAxisRangeMinimumFormatter': {'default': 'charting.secondaryAxis.minimumNumber'},
            'YAxisRangeMaximumFormatter': {'default': 'charting.secondaryAxis.maximumNumber'},
            'YAxisTitleFormatter':  {'default': 'charting.secondaryAxisTitle.text'}
        },
        'table': {
            'Count':        {'count': 'count'},
            'DataOverlay':  {'dataOverlayMode': 'dataOverlayMode'},
            'MaxLines':     {'maxLines': 'maxLines'},
            'RowNumbers':   {'displayRowNumbers': 'displayRowNumbers'},
            'Segmentation': {'segmentation': 'segmentation'},
            'SoftWrap':     {'enable': 'softWrap'}
        }
    },
    
    
    getSettings: function() {
        
        if (!Splunk.Module.loadParams) {
            return {};
        }
        
        //var currentViewstateSet = this.getParam('viewstateSet');
        var currentViewstateSet = this.viewstateKeys['chart'];
        
        var output = {};
        
        // loop through all of the viewstate params in the current view and
        // pull out any that match the current viewstate set; automatically
        // inject those settings into the outgoing settingsMap.
        var x;
        var p = this.getParam('proxyParams');
        for (module in p) {
            if (p.hasOwnProperty(module)) {
                for (key in p[module]) {
                    if (p[module].hasOwnProperty(key)) {
                        if (currentViewstateSet.hasOwnProperty(module)
                            && currentViewstateSet[module].hasOwnProperty(key)) {
                                this.logger.debug('ViewstateAdapter - checking module=' + module + ' key=' + key + ' value=' + p[module][key]);
                                output[currentViewstateSet[module][key]] = p[module][key];
                        }
                    }
                }
            }
        }
        
        return output;
    }

});