Splunk.namespace("Module");

Splunk.Module.AxisScaleFormatter = $.klass(Splunk.Module.BaseChartFormatter, {
   
    initialize: function($super, container){
        $super(container);
   
        this.logger = Splunk.Logger.getLogger("axis_scale_formatter.js");
        this._settingName = "secondaryAxis.scale";
        // if the module is incompatible with the context or with the settings, it will 
        // return this value in addition to hiding itself.
        this._safeDefault = "";
    },
    /*
     * If we are stacking things, we cannot use log scale. 
     * we dont actually *do* anything about it here. See BaseChartFormatter
     */
    isCompatibleWithSettings: function(settingsMap) {
        if (!settingsMap.hasOwnProperty("chart.stackMode")) return true;
        if (settingsMap["chart.stackMode"] == "stacked" || settingsMap["chart.stackMode"] == "stacked100") {
            return false;
        } else {
            return true;
        }   
    }
});