Splunk.namespace("Module");

Splunk.Module.XAxisTitleFormatter = $.klass(Splunk.Module.BaseChartFormatter, {
   
    initialize: function($super, container){
        $super(container);
   
        this.logger = Splunk.Logger.getLogger("x_axis_title_formatter.js");
       
        this._formElement = $("input",this.container)
            .bind("change", this.handleInputChange.bind(this));
       
        this._settingName = "primaryAxisTitle.text";
    },
    getGenericTitle: function() {
        var context = this.getBaseContext();
        var plotIntention = context.popIntention("plot");
        var title = "";
        if (plotIntention && plotIntention["arg"].hasOwnProperty("mode")) {
            var mode = plotIntention["arg"]["mode"];
            if (mode == "timechart") {
                title = "time";
            } else if (mode=="top" || mode=="rare") {
                if (plotIntention["arg"].hasOwnProperty("fields")) {
                    title = plotIntention["arg"]["fields"];
                } else {
                    this.logger.error("top/rare mode, but no fields specified");
                }
            } 
        }
        
        return title;
    },
    /**
     * 'sticky' persistence implementation is not compatible 
     * with how certain modules pick up data-driven defaults.  
     * (by a lucky coincidence the sticky persistence is not even really useful for these modules, so im 
     * pre-emptively short-circuiting it by overriding getSettings
     */
    getSettings: function(){
        var chartArgs = {};
        chartArgs[this._settingName] = this._formElement.val();
        //this.assertParamsMatchUI("getSettings")
        return chartArgs;
    },
    onContextChange: function($super) {
        // if its showing nothing or it's showing the last one we autogenerated
        if (!this._formElement.val() || this._formElement.val() == this._lastGenericTitle) {
            var title = this.getGenericTitle();
            this._lastGenericTitle = title;
            this._formElement.val(title);
            this.setParam("default", title);
        }
        $super();
    }
});