Splunk.Module.DataOverlay = $.klass(Splunk.Module.DispatchingModule, {
    /**
     * Constructor.
     */
    initialize: function($super, container){
        $super(container);
        this.logger = Splunk.Logger.getLogger("Splunk.Module.DataOverlay");
        this.select = $("select[name='dataOverlayMode']", this.container);
        this.select.bind("change", this.handleSelectChange.bind(this));
    },
    /**
     * Returns shared settings for broadcasting.
     */
    getSettings: function(){
        return {"dataOverlayMode": this.getSelectedDataOverlayMode()};
    },
    /**
     * Returns selected option value.
     * 
     * @type String
     * @return The current dataOverlayMode sticky param value or selected value.
     */
    getSelectedDataOverlayMode: function(){
        var val = this.getParam("dataOverlayMode");
        if(!val){
            this.setParam("dataOverlayMode", this.select.val(), true);
        }
        return this.getParam("dataOverlayMode");
    },
    /**
     * Handle an onchange event for the select element.
     * 
     * @param {Object} evt The jQuery fired normalized event.
     */
    handleSelectChange: function(evt) {
        this.setParam('dataOverlayMode', this.select.val());
        this.pushSettingsToChildren();
    }
});