
Splunk.Module.EnablePreview = $.klass(Splunk.Module.DispatchingModule, {
    
        // defines the key used by the module settingsMap services
        SETTINGS_MAP_KEY: 'enablePreview',

        // defines the module configuration key to persist the checkbox state
        CONF_KEY: 'enable',
	
        initialize: function($super, container){
        $super(container);
        this.logger = Splunk.Logger.getLogger("EnablePreview.js");
        this.checkbox = $("input[name='enable']", this.container);
        this.checkbox.bind("click", this.onEnablePreviewChange.bind(this));
    },

    /**
     * Triggered when a user changes the status of the enable preview checkbox.
     */
    onEnablePreviewChange: function(evt){
        this.setParam(this.CONF_KEY, this.isChecked());
        this.logger.info("onEnablePreviewChange - isChecked=" + this.getParam(this.CONF_KEY));
        var context = this.getBaseContext();
        context.job.setPreviewable(this.isChecked());
    },

    onJobProgress: function(event) {
        var context = this.getBaseContext();
        if (context.job.isPreviewable() != this.isChecked()) context.job.setPreviewable(this.isChecked());
    },
    
    /**
     * Framework method always called by triggerSettings page, for instance onclick.
     * Also called directly when the page is loaded to set everyone's initial state
     * Also will be called to embed UI state into permalinks.
     */
    getSettings: function() {
        var output = {};
        output[this.SETTINGS_MAP_KEY] = this.isChecked();
        return output;
    },
   
    /**
     * Returns if the word wrap checkbox has been selected or not.
     */
    isChecked: function() {
        return Splunk.util.normalizeBoolean(this.checkbox.attr('checked'));
    }
});
