Splunk.Module.RowNumbers = $.klass(Splunk.Module.DispatchingModule, {
    /**
     * Constructor.
     */
    initialize: function($super, container){
        $super(container);
        this.logger = Splunk.Logger.getLogger("Splunk.Module.RowNumbers");
        this.checkbox = $("input[name='displayRowNumbers']", this.container);
        this.checkbox.bind("click", this.onRowNumbers.bind(this));
    },
    /**
     * Triggered when a user changes the status of the enable row numbers checkbox.
     * 
     * @param {Object} evt The jQuery fired normalized event.
     */
    onRowNumbers: function(evt){
        this.setParam("displayRowNumbers", this.checkbox.attr("checked"));
        this.pushSettingsToChildren();
    },
    /**
     * Returns shared settings for broadcasting.
     * 
     * @type Object
     * @return An object literal having setting attributes to broacast.
     */
    getSettings: function(){
        var settings = {};
        settings["displayRowNumbers"] = this.isChecked();
        return settings;
    },    
    /**
     * Returns if checkbox has been selected or not.
     * 
     * @type Boolean
     * @return Checked status.
     */
    isChecked: function(){
        if(this.getParam("displayRowNumbers")==null){
            this.setParam("displayRowNumbers", this.checkbox.attr("checked"))
        }
        return Splunk.util.normalizeBoolean(this.getParam("displayRowNumbers"));
    }
});