Splunk.Module.Segmentation = $.klass(Splunk.Module.DispatchingModule, {
    initialize: function($super, container){
        $super(container);
        this.logger = Splunk.Logger.getLogger("Splunk.Module.Segmentation");
        this.select = $("select[name='segmentation']", this.container);
        this.select.bind("change", this.handleSelectChange.bind(this));
    },
    /**
     * Returns shared settings for broadcasting.
     */
    getSettings: function(){
        return {"segmentation": this.getSelectedSegmentation()};
    },
   /**
    * Returns selected option value casted as a number.
    */
   getSelectedSegmentation: function(){
       var val = this.getParam('segmentation');
       if(!val){
           this.setParam('segmentation', this.select.val(), true);
       }
       return this.getParam('segmentation');
   },
   /**
    * Handle select change.
    */
   handleSelectChange: function(evt) {
       this.setParam('segmentation', this.select.val());
       this.pushSettingsToChildren();
   }   
});