Splunk.Module.Selector = $.klass(Splunk.Module, {
    /**
     * Donde estan sus pantalones, Count Dracula?
     */
    initialize: function($super, container){
        $super(container);
        this.logger = Splunk.Logger.getLogger("count.js");
        this.select = $("select[name='"+this._params['name']+"']", this.container);
        this.select.bind("change", function(event) {
            this.pushSettingsToChildren();
        }.bind(this));
        
        if (this._params['mode'] == 'list') {
            this.getResults();
        }
    },
    
    getResultURL: function(params) {
        var uri = '';
        if (this._params['mode'] == 'list') {
            uri = Splunk.util.make_url('api/lists', this._params['listEndpoint']);
            var params = {
                'fields': [JSON.stringify({
                    'label': this._params['text'],
                    'value': this._params['value']
                })],
                'output_mode': 'options'
            }
            if (this._params['selected']) params['selected'] = this._params['selected'];
            uri += '?' + Splunk.util.propToQueryString(params);
        }
        return uri;
    },
    
    renderResults: function(html) {
        $('select', this.container).append($('option', html));
        $('select option[value="*"]', this.container).attr('selected', 'selected');
    },
    
    /**
     * Returns shared settings for broadcasting.
     */
    getSettings: function(){
        var settings = {};
        settings[this._params['name']] = this.select.val();
        return settings;
    }
});
