
Splunk.Module.SoftWrap = $.klass(Splunk.Module.DispatchingModule, {
    
	// defines the key used by the module settingsMap services
	SETTINGS_MAP_KEY: 'softWrap',

	// defines the module configuration key to persist the checkbox state
	CONF_KEY: 'enable',
	
	initialize: function($super, container){
        $super(container);
        this.logger = Splunk.Logger.getLogger("SoftWrap.js");
        this.checkbox = $("input[name='enable']", this.container);
        this.checkbox.bind("click", this.onSoftWrapChange.bind(this));
    },

    /**
     * Triggered when a user changes the status of the soft wrap checkbox.
     */
    onSoftWrapChange: function(evt){
        this.setParam(this.CONF_KEY, this.isChecked());
        this.logger.info("onSoftWrapChange - isChecked=" + this.getParam(this.CONF_KEY));
		this.pushSettingsToChildren();
    },
    
	/**
     * Framework method always called by triggerSettings page, for instance onclick.
     * Also called directly when the page is loaded to set everyone's initial state
     * Also will be called to embed UI state into permalinks.
     */
    getSettings: function() {
		var output = {};
		output[this.SETTINGS_MAP_KEY] = this.isChecked();
		return output;
    },
   
    /**
     * Returns if the word wrap checkbox has been selected or not.
     */
    isChecked: function() {
		return Splunk.util.normalizeBoolean(
			this.checkbox.attr('checked')
		);
    }
});
