
Splunk.Module.HiddenSearch = $.klass(Splunk.Module, {

    initialize: function($super, container) {
        $super(container);
        this.logger = Splunk.Logger.getLogger("hidden_search.js");
        this.messenger = Splunk.Messenger.System.getInstance();
    },

    /**
     * Passes a SearchContext object to its children where the search string is
     * the string defined in the view configuration.
     */   
    getModifiedContext: function() {
        var context = this.getBaseContext();
        context.abandonJob();
        context.setBaseSearch(this._params['search']);
        if (this._params["earliest"] || this._params["latest"]) {
            var range = new Splunk.TimeRange(this._params["earliest"], this._params["latest"]);
            context.setTimeRange(range);
        }
        return context;
    }
});
