//put Module in the namespace if it isnt already there.
Splunk.namespace("Module");

Splunk.Module.ViewRedirectorLink = $.klass(Splunk.Module.ViewRedirector, {
    initialize: function($super, container){
        $super(container);
        
        $("a", this.container)
            .click(function(event){this.sendToView(); return false;}.bind(this))
        // unless dispatchBeforeRedirect is set, there is no reason to show the module until 
        // we receive a context.
        if (!Splunk.util.normalizeBoolean(this._params["dispatchBeforeRedirect"])) {
            $("a", this.container).hide();
        }
    },
    /*
     * update the URL so that on right-click it will at least send them to the sid url.
     */
    onContextChange: function() {
        var path = Splunk.util.make_url("/app/", Splunk.util.getCurrentApp(), this._params["viewTarget"]);
    
        var url = path + "?";
        var context = this.getBaseContext();
        if (context.isJobDispatched) {
            var sid = context.job.getSearchId();
            url += $.param({"sid": sid});
        }
        $("a", this.container)
            .show()
            .attr("href", url);
    },
    /*
     * prevent the context from being pushed to child modules
     */
    pushContextToChildren: function($super, explicitContext) {
        return false;
    }
});